<template>
    <div class="mb-3 row">
        <label :for="labelFor" class="col-sm-4 col-xl-3 col-form-label fw-normal" v-if="!!label">{{ label }}</label>

        <div class="bs-input" :class="'col-sm-' + (!!label ? width:width + 4) + ' col-xl-' + (!!label ? width:width + 4)">
            <input v-if="type=='text' || type=='password'"
                :type="type" class="form-control"
                :name="name"
                :id="labelFor"
                :value="modelValue"
                :placeholder="placeholder"
                :style="style_" :class="class_"
                @input="hide_feedback (); $emit ('update:modelValue', $event.target.value)">

            <select v-else-if="type=='select'"
                aria-label="Default select example" class="form-select"
                :name="name"
                :id="labelFor"
                :style="style_" :class="class_"
                @change="hide_feedback (); $emit ('update:modelValue', $event.target.value)">
                <option v-if="!!placeholder" value='' class="text-grey-darken-2" :selected="!!!modelValue">{{ placeholder }}</option>
                <option v-for="[code, name], index in arrayChoices" :value="code" :key='code' :selected="modelValue == code">{{ name }}</option>
            </select>

            <select v-else-if="type=='select-multiple'"
                aria-label="Default select example" class="form-select"
                :name="name"
                :id="labelFor" multiple
                :style="style_" :class="class_"
                @change="hide_feedback (); updateSelectList ($event.target.value, $event.target)">
                <option v-for="[code, name] in arrayChoices" :value="code" :key='code'
                    :selected="modelValue.includes (code)">{{ name }}</option>
            </select>

            <div v-else-if="type=='radio'" :id="labelFor">
                <div class="form-check" v-for="[code, disp], index in arrayChoices">
                    <input class="form-check-input"
                        :type="type"
                        :id="labelFor + '-' + index"
                        :value="code"
                        :name="name"
                        :checked="modelValue == code"
                        :key='code'
                        :style="style_" :class="class_"
                        @change="hide_feedback (); $emit ('update:modelValue', $event.target.value)">
                    <label class="form-check-label" :for="labelFor + '-' + index" v-html="disp"></label>
                </div>
            </div>

            <div v-else-if="type=='checkbox'" :id="labelFor">
                <div class="form-check" v-for="[code, disp], index in arrayChoices">
                    <input class="form-check-input"
                        :type="type"
                        :id="labelFor + '-' + index"
                        :value="code"
                        :name="name"
                        :checked="modelValue.includes (code)"
                        :key='code'
                        :style="style_" :class="class_"
                        @change="hide_feedback (); updateList (code, $event.target.checked)">
                    <label class="form-check-label" :for="labelFor + '-' + index" v-html="disp"></label>
                </div>
            </div>

            <div class="form-check form-switch" v-else-if="type=='switch'" :id="labelFor">
                <input class="form-check-input" type="checkbox"
                    :value="modelValue"
                    :name="name"
                    :checked = "modelValue == true"
                    :style="style_" :class="class_"
                    @input="hide_feedback (); $emit ('update:modelValue', !modelValue)">
                <label class="form-check-label" :for="labelFor" v-html="placeholder"></label>
            </div>

            <div v-else-if="type=='slider'" :id="labelFor">
                <div class="row">
                    <div class="col-6">
                        <label class="form-check-label" :for="labelFor" v-html="placeholder"></label>
                    </div>
                    <div class="col-4 text-end">
                        <input type="range" class="form-range"
                            :id="name"
                            :name="name"
                            :style="style_" :class="class_"
                            :value="modelValue"
                            :min="range [0]" :max="range [1]" :step="range [2]"
                            @input="hide_feedback (); $emit ('update:modelValue', $event.target.value)">
                    </div>
                    <div class="col-2 text-end">
                        <span class="bg-blue-darken-3 text-light px-2 rounded-2">{{ parseFloat (modelValue).toFixed (props.floatFixed) }}</span>
                    </div>
                </div>
            </div>

            <div class="form-check form-switch" v-else-if="type=='switch-text'" :id="labelFor">
                <div class="row">
                    <div class="col-9">
                        <input class="form-check-input" type="checkbox"
                            :value="modelValue.enabled"
                            :name="name + '_0'"
                            :checked = "modelValue.enabled == true"
                            @input="hide_feedback (); $emit ('update:modelValue', {enabled: !modelValue.enabled, text: modelValue.value})">
                        <label class="form-check-label" :for="labelFor" v-html="placeholder"></label>
                    </div>
                    <div class="col-3 text-end">
                        <input type="text" class="form-control form-control-sm"
                            :name="name + '_1'"
                            :value="modelValue.value"
                            :style="style_" :class="class_"
                            :disabled="!modelValue.enabled"
                            @input="hide_feedback (); $emit ('update:modelValue', {enabled: modelValue.enabled, text: $event.target.value})">
                    </div>
                </div>
            </div>

            <div class="form-check form-switch" v-else-if="type=='switch-slider'" :id="labelFor">
                <div class="row">
                    <div class="col-6">
                        <input class="form-check-input" type="checkbox"
                            :value="modelValue.enabled"
                            :name="name + '_0'"
                            :checked = "modelValue.enabled == true"
                            @input="hide_feedback (); $emit ('update:modelValue', {enabled: !modelValue.enabled, value: modelValue.value})">
                        <label class="form-check-label" :for="labelFor" v-html="placeholder"></label>
                    </div>
                    <div class="col-4 text-end">
                        <input type="range" class="form-range"
                            :id="name"
                            :name="name + '_1'"
                            :style="style_" :class="class_"
                            :disabled="!modelValue.enabled"
                            :value="modelValue.value"
                            :min="range [0]" :max="range [1]" :step="range [2]"
                            @input="hide_feedback (); $emit ('update:modelValue', {enabled: modelValue.enabled, value: $event.target.value})">
                    </div>
                    <div class="col-2 text-end">
                        <span class="bg-blue-darken-3 text-light px-2 rounded-2">{{ parseFloat (modelValue.value).toFixed (props.floatFixed) }}</span>
                    </div>
                </div>
            </div>

            <div class="form-check" v-else-if="type=='bool'" :id="labelFor">
                <input class="form-check-input" type="checkbox"
                    :value="modelValue"
                    :name="name"
                    :checked = "modelValue == true"
                    :style="style_" :class="class_"
                    @input="hide_feedback (); $emit ('update:modelValue', !modelValue)">
                <label class="form-check-label" :for="labelFor" v-html="placeholder"></label>
            </div>

        </div>
    </div>
</template>

<script setup>
const props = defineProps ({
    name: {required: true, Type: String},
    modelValue: {Type: String, default: ''},
    label: {Type: String, default: ''},
    width: {Type: Number, default: 8},
    type: {Type: String, default: 'text'},
    placeholder: {Type: String, default: ''},
    choices: {Type: [Object, Array], default: null},
    range: {Type: Array, default: [0, 100, 1]},
    style_: {Type: String, default: ''},
    class_: {Type: String, default: ''},
    floatFixed: {Type: Number, default: 2},
})
const emit = defineEmits (['update:modelValue'])
const labelFor = 'input-' + props.name.toLowerCase ()
const hide_feedback = frontend.validator.hide_feedback
const arrayChoices = computed (() => {
    if (Array.isArray (props.choices)) {
        return props.choices
    }
    const arr = []
    for (const k in props.choices) {
        arr.push ([props.choices [k], k])
    }
    return arr
})

const checkedItems = ref ([])
function updateList (val, checked) {
    if (checked) {
        checkedItems.value.push (val)
    } else {
        checkedItems.value.splice(checkedItems.value.indexOf (val), 1)
    }
    emit ('update:modelValue', checkedItems.value)
}

function updateSelectList (val, values) {
    checkedItems.value = []
    for (let i = 0; i < values.length; i++) {
        if (values [i].selected) {
            checkedItems.value.push (values [i].value)
        }
    }
    emit ('update:modelValue', checkedItems.value)
}
</script>
